#property copyright "Copyright  2006-2009, Sergey Kravchuk. http://forextools.com.ua"
#property link      "http://forextools.com.ua"
#property library

#import "FreeImage.dll"
   void _FreeImage_Initialise@4(int a0);
   void _FreeImage_DeInitialise@0();
   int _FreeImage_Load@12(int a0, string a1, int a2);
   int _FreeImage_ConvertTo24Bits@4(int a0);
   int _FreeImage_GetWidth@4(int a0);
   int _FreeImage_GetHeight@4(int a0);
   bool _FreeImage_GetPixelColor@16(int a0, int a1, int a2, int& a3[]);
   bool _FreeImage_SetPixelColor@16(int a0, int a1, int a2, int& a3[]);
   int _FreeImage_Copy@20(int a0, int a1, int a2, int a3, int a4);
   int _FreeImage_RotateClassic@12(int a0, double a1);
#import

string gs_unused_76 = "MQL wrapper for FreeImage.dll";

void fi_SetPixel(int ai_0, int ai_4, int ai_8, int ai_12) {
   int lia_16[] = {0};
   lia_16[0] = ai_12;
   int li_20 = _FreeImage_GetHeight@4(ai_0);
   _FreeImage_SetPixelColor@16(ai_0, ai_4, li_20 - 1 - ai_8, lia_16);
}

int fi_GetPixel(int ai_0, int ai_4, int ai_8) {
   int lia_12[] = {-1};
   int li_16 = _FreeImage_GetHeight@4(ai_0);
   _FreeImage_GetPixelColor@16(ai_0, ai_4, li_16 - 1 - ai_8, lia_12);
   return (lia_12[0]);
}

int fi_CopyBox(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16) {
   return (_FreeImage_Copy@20(ai_0, ai_4, ai_8, ai_12 + 1, ai_16 + 1));
}

int fi_CropBox(int ai_0, int &ai_4, int &ai_8, int &ai_12, int &ai_16, int ai_20) {
   int li_32;
   for (ai_4 = ai_4; ai_4 <= ai_12; ai_4++) {
      for (int li_28 = ai_8; li_28 <= ai_16; li_28++) {
         li_32 = fi_GetPixel(ai_0, ai_4, li_28);
         if (li_32 != ai_20) break;
      }
      if (li_32 != ai_20) break;
   }
   for (ai_12 = ai_12; ai_12 >= ai_4; ai_12--) {
      for (li_28 = ai_8; li_28 <= ai_16; li_28++) {
         li_32 = fi_GetPixel(ai_0, ai_12, li_28);
         if (li_32 != ai_20) break;
      }
      if (li_32 != ai_20) break;
   }
   for (ai_8 = ai_8; ai_8 <= ai_16; ai_8++) {
      for (int li_24 = ai_4; li_24 <= ai_12; li_24++) {
         li_32 = fi_GetPixel(ai_0, li_24, ai_8);
         if (li_32 != ai_20) break;
      }
      if (li_32 != ai_20) break;
   }
   for (ai_16 = ai_16; ai_16 >= ai_8; ai_16--) {
      for (li_24 = ai_4; li_24 <= ai_12; li_24++) {
         li_32 = fi_GetPixel(ai_0, li_24, ai_16);
         if (li_32 != ai_20) break;
      }
      if (li_32 != ai_20) break;
   }
   return (fi_CopyBox(ai_0, ai_4, ai_8, ai_12, ai_16));
}

int fi_CropBoxOnly(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16, int ai_20) {
   int li_24 = ai_4;
   int li_28 = ai_8;
   int li_32 = ai_12;
   int li_36 = ai_16;
   return (fi_CropBox(ai_0, li_24, li_28, li_32, li_36, ai_20));
}

void GetBorderPrices(int ai_0, double &a_str2dbl_4, int &ai_12, double &a_str2dbl_16, int &ai_24, int ai_28) {
   int li_48;
   int li_52 = fi_CopyBox(ai_0, 76, 198, 434, 241);
   ai_0 = _FreeImage_RotateClassic@12(li_52, -90.0);
   int li_56 = _FreeImage_GetWidth@4(ai_0);
   int li_60 = _FreeImage_GetHeight@4(ai_0);
   for (int l_count_40 = 0; l_count_40 < li_60; l_count_40++) {
      for (int l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, l_count_40);
         if (li_48 != ai_28) break;
      }
      if (li_48 != ai_28) break;
   }
   for (l_count_40 = l_count_40; l_count_40 < li_60; l_count_40++) {
      for (l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, l_count_40);
         if (li_48 != ai_28) break;
      }
      if (l_count_32 >= li_56) break;
   }
   for (l_count_40 = l_count_40; l_count_40 < li_60; l_count_40++) {
      for (l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, l_count_40);
         if (li_48 != ai_28) break;
      }
      if (li_48 != ai_28) break;
   }
   for (int li_44 = l_count_40; li_44 < li_60; li_44++) {
      for (l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, li_44);
         if (li_48 != ai_28) break;
      }
      if (l_count_32 >= li_56) break;
   }
   ai_12 = l_count_40 + 76 + 3;
   int li_64 = fi_CopyBox(ai_0, 0, l_count_40, li_56 - 1, li_44 - 1);
   a_str2dbl_4 = StrToDouble(OcrImage(li_64, ai_28, 0));
   for (l_count_40 = li_44; l_count_40 < li_60; l_count_40++) {
      for (l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, l_count_40);
         if (li_48 != ai_28) break;
      }
      if (li_48 != ai_28) break;
   }
   for (li_44 = l_count_40; li_44 < li_60; li_44++) {
      for (l_count_32 = 0; l_count_32 < li_56; l_count_32++) {
         li_48 = fi_GetPixel(ai_0, l_count_32, li_44);
         if (li_48 != ai_28) break;
      }
      if (l_count_32 >= li_56) break;
   }
   ai_24 = l_count_40 + 76 + 3;
   li_64 = fi_CopyBox(ai_0, 0, l_count_40, li_56 - 1, li_44 - 1);
   a_str2dbl_16 = StrToDouble(OcrImage(li_64, ai_28, 0));
}

void GetMaskImages(string a_name_0, int ai_8, int ai_12, int ai_16, int a_count_20, int ai_24, int ai_28) {
   int li_40;
   int li_64;
   int li_68;
   int li_72;
   int l_file_76;
   string ls_44 = "";
   int li_52 = _FreeImage_GetWidth@4(ai_8);
   int li_56 = _FreeImage_GetHeight@4(ai_8);
   ai_8 = fi_CopyBox(ai_8, ai_12, ai_16, a_count_20, ai_24);
   for (int l_count_60 = 0; l_count_60 < 5; l_count_60++) {
      li_52 = _FreeImage_GetWidth@4(ai_8);
      li_56 = _FreeImage_GetHeight@4(ai_8);
      ai_8 = fi_CropBoxOnly(ai_8, 0, 0, li_52 - 1, li_56 - 1, ai_28);
      li_52 = _FreeImage_GetWidth@4(ai_8);
      li_56 = _FreeImage_GetHeight@4(ai_8);
      for (a_count_20 = 0; a_count_20 < li_52; a_count_20++) {
         for (int l_count_36 = 0; l_count_36 < li_56; l_count_36++) {
            li_40 = fi_GetPixel(ai_8, a_count_20, l_count_36);
            if (li_40 != ai_28) break;
         }
         if (l_count_36 >= li_56) break;
      }
      li_64 = fi_CopyBox(ai_8, 0, 0, a_count_20 - 1, li_56 - 1);
      li_68 = _FreeImage_GetWidth@4(li_64);
      li_72 = _FreeImage_GetHeight@4(li_64);
      li_64 = fi_CropBoxOnly(li_64, 0, 0, li_68 - 1, li_72 - 1, ai_28);
      li_68 = _FreeImage_GetWidth@4(li_64);
      li_72 = _FreeImage_GetHeight@4(li_64);
      l_file_76 = FileOpen(a_name_0, FILE_CSV|FILE_WRITE|FILE_READ, CharToStr(9));
      FileSeek(l_file_76, 2, SEEK_SET);
      if (l_file_76 == -1) {
         Print(a_name_0 + " not created");
         return;
      }
      for (l_count_36 = 0; l_count_36 < li_72; l_count_36++) {
         ls_44 = "";
         for (int l_count_32 = 0; l_count_32 < li_68; l_count_32++) {
            if (fi_GetPixel(li_64, l_count_32, l_count_36) != ai_28) ls_44 = ls_44 + "=";
            else ls_44 = ls_44 + " ";
         }
         FileWrite(l_file_76, ls_44);
      }
      FileWrite(l_file_76, 
      "\n");
      FileClose(l_file_76);
      if (a_count_20 >= li_52) break;
      ai_8 = fi_CropBoxOnly(ai_8, a_count_20, 0, li_52 - 1, li_56 - 1, ai_28);
   }
}

string OcrImage(int ai_0, int ai_4, int ai_8) {
   int li_20;
   string lsa_56[15];
   string lsa_60[15];
   string lsa_64[256];
   string lsa_68[256];
   int li_76;
   int li_80;
   int li_84;
   int li_88;
   int li_92;
   string ls_ret_40 = "";
   string ls_48 = "";
   lsa_60[0] = "A";
   lsa_56[0] = "  ==  " + " =  = " + "=    =" + "=    =" + "=    =" + "======" + "=    =" + "=    =" + "=    =" + "=    =";
   lsa_60[1] = "B";
   lsa_56[1] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=    =" + "=    =" + "=    =" + "=    =" + "===== ";
   lsa_60[2] = "C";
   lsa_56[2] = " ==== " + "=    =" + "=     " + "=     " + "=     " + "=     " + "=     " + "=     " + "=    =" + " ==== ";
   lsa_60[3] = "D";
   lsa_56[3] = "====  " + "=   = " + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=   = " + "====  ";
   lsa_60[4] = "E";
   lsa_56[4] = "======" + "=     " + "=     " + "=     " + "===== " + "=     " + "=     " + "=     " + "=     " + "======";
   lsa_60[5] = "F";
   lsa_56[5] = "======" + "=     " + "=     " + "=     " + "===== " + "=     " + "=     " + "=     " + "=     " + "=     ";
   lsa_60[6] = "G";
   lsa_56[6] = " ==== " + "=    =" + "=     " + "=     " + "=     " + "=  ===" + "=    =" + "=    =" + "=   ==" + " === =";
   lsa_60[7] = "H";
   lsa_56[7] = "=    =" + "=    =" + "=    =" + "=    =" + "======" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =";
   lsa_60[8] = "J";
   lsa_56[8] = "   ===" + "    = " + "    = " + "    = " + "    = " + "    = " + "    = " + "=   = " + "=   = " + " ===  ";
   lsa_60[9] = "P";
   lsa_56[9] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=     " + "=     " + "=     " + "=     " + "=     ";
   lsa_60[10] = "R";
   lsa_56[10] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=  =  " + "=   = " + "=   = " + "=    =" + "=    =";
   lsa_60[11] = "S";
   lsa_56[11] = " ==== " + "=    =" + "=    =" + "=     " + " ==   " + "   == " + "     =" + "=    =" + "=    =" + " ==== ";
   lsa_60[12] = "U";
   lsa_56[12] = "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + " ==== ";
   lsa_60[13] = "Y";
   lsa_56[13] = "=     =" + "=     =" + " =   = " + " =   = " + "  = =  " + "   =   " + "   =   " + "   =   " + "   =   " + "   =   ";
   lsa_60[14] = "";
   lsa_56[14] = "";
   lsa_68[32] = " ";
   lsa_64[32] = "";
   lsa_68[33] = "!";
   lsa_64[33] = "";
   lsa_68[34] = "\"";
   lsa_64[34] = "";
   lsa_68[35] = "#";
   lsa_64[35] = "";
   lsa_68[36] = "$";
   lsa_64[36] = "";
   lsa_68[37] = "%";
   lsa_64[37] = " =  =" + "= = =" + " = = " + "   = " + "  =  " + " =   " + " = = " + "= = =" + "=  = ";
   lsa_68[38] = "&";
   lsa_64[38] = "";
   lsa_68[39] = "\'";
   lsa_64[39] = "";
   lsa_68[40] = "(";
   lsa_64[40] = "  =" + " = " + "=  " + "=  " + "=  " + "=  " + " = " + "  =";
   lsa_68[41] = ")";
   lsa_64[41] = "=  " + " = " + "  =" + "  =" + "  =" + "  =" + " = " + "=  ";
   lsa_68[42] = "*";
   lsa_64[42] = "";
   lsa_68[43] = "+";
   lsa_64[43] = "  =  " + "  =  " + "=====" + "  =  " + "  =  " + "     ";
   lsa_68[44] = ",";
   lsa_64[44] = "";
   lsa_68[45] = "-";
   lsa_64[45] = "=====";
   lsa_68[46] = ".";
   lsa_64[46] = "==" + "==";
   lsa_68[47] = "/";
   lsa_64[47] = "    =" + "    =" + "   = " + "   = " + "  =  " + " =   " + " =   " + "=    " + "=    ";
   lsa_68[48] = "0";
   lsa_64[48] = "  =  " + " = = " + "=   =" + "=   =" + "=   =" + "=   =" + " = = " + "  =  ";
   lsa_68[49] = "1";
   lsa_64[49] = "  =  " + " ==  " + "= =  " + "  =  " + "  =  " + "  =  " + "  =  " + "=====";
   lsa_68[50] = "2";
   lsa_64[50] = " === " + "=   =" + "    =" + "   = " + "  =  " + " =   " + "=    " + "=====";
   lsa_68[51] = "3";
   lsa_64[51] = " === " + "=   =" + "    =" + "  == " + "    =" + "    =" + "=   =" + " === ";
   lsa_68[52] = "4";
   lsa_64[52] = "   = " + "  == " + " = = " + "=  = " + "=  = " + "=====" + "   = " + "   = ";
   lsa_68[53] = "5";
   lsa_64[53] = "=====" + "=    " + "==== " + "=   =" + "    =" + "    =" + "=   =" + " === ";
   lsa_68[54] = "6";
   lsa_64[54] = "  ===" + " =   " + "=    " + "==== " + "=   =" + "=   =" + "=   =" + " === ";
   lsa_68[55] = "7";
   lsa_64[55] = "=====" + "    =" + "   = " + "   = " + "  =  " + "  =  " + " =   " + " =   ";
   lsa_68[56] = "8";
   lsa_64[56] = " === " + "=   =" + "=   =" + " === " + "=   =" + "=   =" + "=   =" + " === ";
   lsa_68[57] = "9";
   lsa_64[57] = " === " + "=   =" + "=   =" + "=   =" + " ====" + "    =" + "   = " + "===  ";
   lsa_68[58] = ":";
   lsa_64[58] = "==" + "==" + "  " + "  " + "==" + "==";
   lsa_68[59] = ";";
   lsa_64[59] = "";
   lsa_68[60] = "<";
   lsa_64[60] = "";
   lsa_68[61] = "=";
   lsa_64[61] = "";
   lsa_68[62] = ">";
   lsa_64[62] = "";
   lsa_68[63] = "?";
   lsa_64[63] = "";
   lsa_68[64] = "@";
   lsa_64[64] = "";
   lsa_68[65] = "A";
   lsa_64[65] = "  =  " + " = = " + "=   =" + "=   =" + "=====" + "=   =" + "=   =" + "=   =";
   lsa_68[66] = "B";
   lsa_64[66] = "==== " + "=   =" + "=   =" + "==== " + "=   =" + "=   =" + "=   =" + "==== ";
   lsa_68[67] = "C";
   lsa_64[67] = " === " + "=   =" + "=    " + "=    " + "=    " + "=    " + "=   =" + " === ";
   lsa_68[68] = "D";
   lsa_64[68] = "==== " + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "==== ";
   lsa_68[69] = "E";
   lsa_64[69] = "=====" + "=    " + "=    " + "==== " + "=    " + "=    " + "=    " + "=====";
   lsa_68[70] = "F";
   lsa_64[70] = "=====" + "=    " + "=    " + "==== " + "=    " + "=    " + "=    " + "=    ";
   lsa_68[71] = "G";
   lsa_64[71] = " === " + "=   =" + "=    " + "=    " + "=  ==" + "=   =" + "=   =" + " === ";
   lsa_68[72] = "H";
   lsa_64[72] = "=   =" + "=   =" + "=   =" + "=====" + "=   =" + "=   =" + "=   =" + "=   = ";
   lsa_68[73] = "I";
   lsa_64[73] = "";
   lsa_68[74] = "J";
   lsa_64[74] = "   =" + "   =" + "   =" + "   =" + "   =" + "   =" + "=  =" + " == ";
   lsa_68[75] = "K";
   lsa_64[75] = "";
   lsa_68[76] = "L";
   lsa_64[76] = "=    " + "=    " + "=    " + "=    " + "=    " + "=    " + "=    " + "=====";
   lsa_68[77] = "M";
   lsa_64[77] = "=   =" + "== ==" + "= = =" + "= = =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_68[78] = "N";
   lsa_64[78] = "=   =" + "==  =" + "==  =" + "= = =" + "= = =" + "=  ==" + "=  ==" + "=   =";
   lsa_68[79] = "O";
   lsa_64[79] = " === " + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_68[80] = "P";
   lsa_64[80] = "==== " + "=   =" + "=   =" + "=   =" + "==== " + "=    " + "=    " + "=    ";
   lsa_68[81] = "Q";
   lsa_64[81] = "";
   lsa_68[82] = "R";
   lsa_64[82] = "==== " + "=   =" + "=   =" + "=   =" + "==== " + "= =  " + "=  = " + "=   =";
   lsa_68[83] = "S";
   lsa_64[83] = " === " + "=   =" + "=    " + " ==  " + "   = " + "    =" + "=   =" + " === ";
   lsa_68[84] = "T";
   lsa_64[84] = "=====" + "  =  " + "  =  " + "  =  " + "  =  " + "  =  " + "  =  " + "  =  ";
   lsa_68[85] = "U";
   lsa_64[85] = "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_68[86] = "V";
   lsa_64[86] = "";
   lsa_68[87] = "W";
   lsa_64[87] = "=   =" + "=   =" + "= = =" + "= = =" + "= = =" + "= = =" + "== ==" + " = = ";
   lsa_68[88] = "X";
   lsa_64[88] = "";
   lsa_68[89] = "Y";
   lsa_64[89] = "=   =" + "=   =" + " = = " + " = = " + "  =  " + "  =  " + "  =  " + "  =  ";
   lsa_68[90] = "Z";
   lsa_64[90] = "";
   lsa_68[91] = "[";
   lsa_64[91] = "";
   lsa_68[92] = "\\";
   lsa_64[92] = "";
   lsa_68[93] = "]";
   lsa_64[93] = "";
   lsa_68[94] = "^";
   lsa_64[94] = "";
   lsa_68[95] = "_";
   lsa_64[95] = "";
   lsa_68[96] = "`";
   lsa_64[96] = "";
   lsa_68[97] = "a";
   lsa_64[97] = " === " + "    =" + " ====" + "=   =" + "=  ==" + " == =";
   lsa_68[98] = "b";
   lsa_64[98] = "=    " + "=    " + "= == " + "==  =" + "=   =" + "=   =" + "==  =" + "= == ";
   lsa_68[99] = "c";
   lsa_64[99] = " === " + "=   =" + "=    " + "=    " + "=   =" + " === ";
   lsa_68[100] = "d";
   lsa_64[100] = "    =" + "    =" + " == =" + "=  ==" + "=   =" + "=   =" + "=  ==" + " == =";
   lsa_68[101] = "e";
   lsa_64[101] = " === " + "=   =" + "=====" + "=    " + "=    " + " === ";
   lsa_68[102] = "f";
   lsa_64[102] = "  == " + " =  =" + " =   " + " =   " + "==== " + " =   " + " =   " + " =   ";
   lsa_68[103] = "g";
   lsa_64[103] = "    =" + " === " + "=   =" + "=   =" + " === " + "=    " + " === " + "=   =" + " === ";
   lsa_68[104] = "h";
   lsa_64[104] = "=    " + "=    " + "= == " + "==  =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_68[105] = "i";
   lsa_64[105] = " = " + "   " + "== " + " = " + " = " + " = " + " = " + "===";
   lsa_68[106] = "j";
   lsa_64[106] = "";
   lsa_68[107] = "k";
   lsa_64[107] = "=    " + "=    " + "=  = " + "= =  " + "==   " + "= =  " + "=  = " + "=   =";
   lsa_68[108] = "l";
   lsa_64[108] = "== " + " = " + " = " + " = " + " = " + " = " + " = " + "===";
   lsa_68[109] = "m";
   lsa_64[109] = "== = " + "= = =" + "= = =" + "= = =" + "= = =" + "=   =";
   lsa_68[110] = "n";
   lsa_64[110] = "= == " + "==  =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_68[111] = "o";
   lsa_64[111] = " === " + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_68[112] = "p";
   lsa_64[112] = "= == " + "==  =" + "=   =" + "=   =" + "==  =" + "= == " + "=    " + "=    ";
   lsa_68[113] = "q";
   lsa_64[113] = " == =" + "=  ==" + "=   =" + "=   =" + "=  ==" + " == =" + "    =" + "    =";
   lsa_68[114] = "r";
   lsa_64[114] = "= == " + "==  =" + "=    " + "=    " + "=    " + "=    ";
   lsa_68[115] = "s";
   lsa_64[115] = " === " + "=   =" + " ==  " + "   = " + "=   =" + " === ";
   lsa_68[116] = "t";
   lsa_64[116] = " =   " + " =   " + "==== " + " =   " + " =   " + " =   " + " =  =" + "  == ";
   lsa_68[117] = "u";
   lsa_64[117] = "=   =" + "=   =" + "=   =" + "=   =" + "=  ==" + " == =";
   lsa_68[118] = "v";
   lsa_64[118] = "=   =" + "=   =" + "=   =" + " = = " + " = = " + "  =  ";
   lsa_68[119] = "w";
   lsa_64[119] = "=   =" + "=   =" + "= = =" + "= = =" + "= = =" + " = = ";
   lsa_68[120] = "x";
   lsa_64[120] = "=   =" + " = = " + "  =  " + "  =  " + " = = " + "=   =";
   lsa_68[121] = "y";
   lsa_64[121] = "=   =" + "=   =" + "=   =" + "=  ==" + " == =" + "    =" + "   = " + "===  ";
   lsa_68[122] = "z";
   lsa_64[122] = "=====" + "   = " + "  =  " + "  =  " + " =   " + "=====";
   lsa_68[123] = "{";
   lsa_64[123] = "";
   lsa_68[124] = "|";
   lsa_64[124] = "";
   lsa_68[125] = "}";
   lsa_64[125] = "";
   lsa_68[126] = "~";
   lsa_64[126] = "";
   lsa_68[127] = "";
   lsa_64[127] = "";
   for (int l_count_72 = 0; l_count_72 < 200; l_count_72++) {
      li_76 = _FreeImage_GetWidth@4(ai_0);
      li_80 = _FreeImage_GetHeight@4(ai_0);
      ai_0 = fi_CropBoxOnly(ai_0, 0, 0, li_76 - 1, li_80 - 1, ai_4);
      li_76 = _FreeImage_GetWidth@4(ai_0);
      li_80 = _FreeImage_GetHeight@4(ai_0);
      for (int l_count_32 = 0; l_count_32 < li_76; l_count_32++) {
         for (int l_index_16 = 0; l_index_16 < li_80; l_index_16++) {
            li_20 = fi_GetPixel(ai_0, l_count_32, l_index_16);
            if (li_20 != ai_4) break;
         }
         if (l_index_16 >= li_80) break;
      }
      li_84 = fi_CopyBox(ai_0, 0, 0, l_count_32 - 1, li_80 - 1);
      li_88 = _FreeImage_GetWidth@4(li_84);
      li_92 = _FreeImage_GetHeight@4(li_84);
      li_84 = fi_CropBoxOnly(li_84, 0, 0, li_88 - 1, li_92 - 1, ai_4);
      li_88 = _FreeImage_GetWidth@4(li_84);
      li_92 = _FreeImage_GetHeight@4(li_84);
      ls_48 = "";
      for (l_index_16 = 0; l_index_16 < li_92; l_index_16++) {
         for (int l_count_12 = 0; l_count_12 < li_88; l_count_12++) {
            if (fi_GetPixel(li_84, l_count_12, l_index_16) != ai_4) ls_48 = ls_48 + "=";
            else ls_48 = ls_48 + " ";
         }
      }
      if (ai_8 == 0) {
         for (l_index_16 = 0; l_index_16 < ArraySize(lsa_68); l_index_16++)
            if (lsa_64[l_index_16] == ls_48) break;
         ls_ret_40 = ls_ret_40 + lsa_68[l_index_16];
      }
      if (ai_8 == 1) {
         for (l_index_16 = 0; l_index_16 < ArraySize(lsa_60); l_index_16++)
            if (lsa_56[l_index_16] == ls_48) break;
         ls_ret_40 = ls_ret_40 + lsa_60[l_index_16];
      }
      if (l_count_32 >= li_76) break;
      ai_0 = fi_CropBoxOnly(ai_0, l_count_32, 0, li_76 - 1, li_80 - 1, ai_4);
   }
   return (ls_ret_40);
}

string InternetGetPicture(string as_0, int ai_8, string &asa_12[], int &aia_16[], int &aia_20[], double &ada_24[], int &aia_28[], int &aia_32[]) {
   double l_str2dbl_96;
   int li_104;
   double l_str2dbl_108;
   int li_116;
   int li_92 = -1;
   _FreeImage_Initialise@4(0);
   int li_36 = _FreeImage_Load@12(13, as_0, 0);
   li_36 = _FreeImage_ConvertTo24Bits@4(li_36);
   if (li_36 == 0) {
      Print("Error #1 while processing file " + TerminalPath() + "\\experts\\files\\" + as_0);
      _FreeImage_DeInitialise@0();
      return ("");
   }
   int li_40 = _FreeImage_GetWidth@4(li_36);
   int li_44 = _FreeImage_GetHeight@4(li_36);
   string ls_120 = OcrImage(fi_CopyBox(li_36, 0, 236, 253, 255), 16777215, 0);
   if (StringFind(ls_120, "Orders") >= 0) ls_120 = "o";
   else ls_120 = "t";
   string ls_ret_128 = OcrImage(fi_CopyBox(li_36, 0, 0, 66, 22), 16777215, 1);
   int li_136 = 0;
   string ls_140 = OcrImage(fi_CopyBox(li_36, 336, 0, 530, 22), 16777215, 0);
   int l_index_80 = StringLen(ls_140);
   string ls_148 = StringSubstr(ls_140, l_index_80 - 4, 4);
   string ls_156 = StringSubstr(ls_140, l_index_80 - 12, 8);
   string ls_164 = "";
   string ls_172 = "";
   if (StringSubstr(ls_140, l_index_80 - 14, 1) > "9") {
      ls_172 = StringSubstr(ls_140, l_index_80 - 13, 1);
      ls_164 = StringSubstr(ls_140, l_index_80 - 15, 2);
   } else {
      ls_172 = StringSubstr(ls_140, l_index_80 - 14, 2);
      ls_164 = StringSubstr(ls_140, l_index_80 - 16, 2);
   }
   int li_180 = 0;
   if (ls_164 == "an") li_180 = 1;
   if (ls_164 == "eb") li_180 = 2;
   if (ls_164 == "ar") li_180 = 3;
   if (ls_164 == "pr") li_180 = 4;
   if (ls_164 == "ay") li_180 = 5;
   if (ls_164 == "un") li_180 = 6;
   if (ls_164 == "ul") li_180 = 7;
   if (ls_164 == "ug") li_180 = 8;
   if (ls_164 == "ep") li_180 = 9;
   if (ls_164 == "ct") li_180 = 10;
   if (ls_164 == "ov") li_180 = 11;
   if (ls_164 == "ec") li_180 = 12;
   li_136 = StrToTime(ls_148 + "." + li_180 + "." + ls_172 + " " + ls_156) + 60 * (60 * ai_8);
   GetBorderPrices(li_36, l_str2dbl_96, li_104, l_str2dbl_108, li_116, 16777215);
   for (int l_count_48 = 0; l_count_48 < li_40; l_count_48++)
      if (fi_GetPixel(li_36, l_count_48, li_44 / 2) == 16744192) break;
   if (l_count_48 >= li_40) {
      for (l_count_48 = 0; l_count_48 < li_40; l_count_48++)
         if (fi_GetPixel(li_36, l_count_48, li_44 / 2 + 1) == 16744192) break;
   }
   if (l_count_48 >= li_40) {
      for (l_count_48 = 0; l_count_48 < li_40; l_count_48++)
         if (fi_GetPixel(li_36, l_count_48, li_44 / 2 - 1) == 16744192) break;
   }
   for (int li_60 = li_44 / 2; li_60 < li_44; li_60++) {
      li_92 = fi_GetPixel(li_36, l_count_48, li_60);
      if (li_92 != 16744192 && li_92 != 9474192) break;
   }
   li_60--;
   for (int li_56 = li_44 / 2; li_56 > 0; li_56--) {
      li_92 = fi_GetPixel(li_36, l_count_48, li_56);
      if (li_92 != 16744192 && li_92 != 9474192) break;
   }
   li_56++;
   int li_52 = li_60 - li_56 + 1;
   for (int li_64 = li_56; li_64 <= li_60; li_64++)
      if (fi_GetPixel(li_36, l_count_48 - 1, li_64) == 0) break;
   if (li_64 > li_60) {
      for (li_64 = li_56; li_64 <= li_60; li_64++)
         if (fi_GetPixel(li_36, l_count_48 + 1, li_64) == 0) break;
   }
   for (int li_76 = l_count_48 + 1; li_76 < li_40; li_76++) {
      li_92 = fi_GetPixel(li_36, li_76, li_64);
      if (li_92 != 0 && li_92 != 9474192) break;
   }
   li_76--;
   for (int li_72 = l_count_48 - 1; li_72 > 0; li_72--) {
      li_92 = fi_GetPixel(li_36, li_72, li_64);
      if (li_92 != 0 && li_92 != 9474192) break;
   }
   li_72++;
   int li_68 = li_76 - li_72 + 1;
   ArrayResize(asa_12, li_68);
   ArrayResize(aia_16, li_68);
   ArrayResize(aia_20, li_68);
   ArrayResize(ada_24, li_68);
   ArrayResize(aia_28, li_68);
   ArrayResize(aia_32, li_68);
   double ld_184 = (l_str2dbl_108 - l_str2dbl_96) / (li_116 - li_104);
   double ld_192 = l_str2dbl_96 - (li_104 - li_72) * ld_184;
   l_index_80 = 0;
   for (int li_84 = li_72; li_84 <= li_76; li_84++) {
      for (int li_88 = li_60; li_88 > li_64; li_88--) {
         li_92 = fi_GetPixel(li_36, li_84, li_88);
         if (li_92 != 16777215 && li_92 != 9474192) break;
      }
      aia_32[l_index_80] = li_88 - li_64;
      for (li_88 = li_56; li_88 < li_64; li_88++) {
         li_92 = fi_GetPixel(li_36, li_84, li_88);
         if (li_92 != 16777215 && li_92 != 9474192) break;
      }
      aia_28[l_index_80] = li_64 - li_88;
      aia_20[l_index_80] = li_84 - l_count_48;
      aia_16[l_index_80] = li_136;
      if (li_84 == l_count_48) ada_24[l_index_80] = NormalizeDouble(StrToDouble(OcrImage(fi_CropBoxOnly(li_36, 76, 25, 434, 44, 16777215), 16777215, 0)), Digits);
      else ada_24[l_index_80] = NormalizeDouble(ld_192 + (li_84 - li_72) * ld_184, Digits);
      asa_12[l_index_80] = ls_120;
      l_index_80++;
   }
   _FreeImage_DeInitialise@0();
   return (ls_ret_128);
}
